Name:		putty-tools
Version:	0.60
Release:	1
Summary:	PuTTY command-line utilities
License:	MIT
URL:		http://www.chiark.greenend.org.uk/~sgtatham/putty/
Group:		Applications/Internet
Packager:	Jonathan Tai <jon.tai@medsphere.com>

Conflicts:	putty

Source:		putty-%{version}.tar.gz
Patch:		putty-tools_fix-make-install.patch
BuildRoot:	%{_tmppath}/%{name}-root

%description
PuTTY is a free implementation of Telnet and SSH for Win32 and Unix platforms,
along with an xterm terminal emulator. It is written and maintained primarily
by Simon Tatham. 

This package contains only the PuTTY command-line utilities (PSCP, PSFTP,
Plink, PuTTYgen).  If you want the GTK programs, install the putty package
instead.

%prep
%setup -n putty-%{version}
%patch -p0

%build
cd unix
./configure --prefix=/usr
make

%install
rm -rf %{buildroot}

install -d %{buildroot}%{_bindir}
install -d %{buildroot}%{_mandir}/man1

cd unix
make DESTDIR=%{buildroot} install

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc CHECKLST.txt LICENCE README* doc/*.html doc/*.txt
%doc %{_mandir}/man1/plink.1.gz
%doc %{_mandir}/man1/pscp.1.gz
%doc %{_mandir}/man1/psftp.1.gz
%doc %{_mandir}/man1/puttygen.1.gz
%{_bindir}/plink
%{_bindir}/pscp
%{_bindir}/psftp
%{_bindir}/puttygen
