; Copyright (C) 2009 Medsphere Systems Corporation
;
; This program is free software; you can redistribute it and/or modify it
; solely under the terms of the GNU Affero General Public License version 3 as
; published by the Free Software Foundation.
; 
; This program is distributed in the hope that it will be useful, but WITHOUT
; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
; FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Affero General Public License
; for more details.
; 
; You should have received a copy of the GNU Affero General Public License
; along with this program.  If not, see <http://www.gnu.org/licenses>.
; 
; You can contact Medsphere Systems Corporation headquarters at 1917 Palomar 
; Oaks Way, Suite 200, Carlsbad, CA 92008 or at legal@medsphere.com. 
; Demonstrate how to pas file descriptors to child processes.

; SRVFORK uses a simple fork in the client to duplicate only the accepted
; socket to the stdin and stdout of the child.
GTMSRV
 Q
SRVFORK(PORTNO,CMD) ; Client is a simple fork
 N TCPDEV,TIMEOUT
 Set TCPDEV="server$"_$j,TIMEOUT=3000 ; Doesn't handle TIMEOUTs correctly yet
 Open TCPDEV:(ZLISTEN=PORTNO_":TCP":attach="listener"):TIMEOUT:"SOCKET"
 Use TCPDEV
 Write /listen(1)
 F  D
 . Use TCPDEV:(SOCKET="listener")
 . Write /wait(TIMEOUT)
 . N HANDLE S HANDLE=$P($KEY,"|",2)
 . K ZS ZSHOW "D":ZS
 . N IDX,DESC S DESC="" F IDX=1:1:$O(ZS("D",""),-1) D  Q:DESC'=""
 . . S:ZS("D",IDX)[HANDLE DESC=$P($P(ZS("D",IDX),"DESC=",2)," ",1)
 . . Q
 . D &gtmserver(DESC,CMD)
 . C TCPDEV:(socket=HANDLE)
 . Q
 Q
ECHOTEST
 W "My $J is "_$J,!
 W "I will echo. Enter 'BYE' to exit.",!
 N INTEXT,OUTTEXT
 F  R INTEXT#5 Q:INTEXT["BYE"  S OUTTEXT="echo##"_$E(INTEXT,1,$L(INTEXT)-1)_"##" W OUTTEXT,!
 Q
